#include "math1.h"
#include <float.h>
#include "data_base.h"
#include "puls.h"

#include <stdio.h>




// 2005.01.01 konstansok kiszedve a rambl
// todo 2010 06.03 ra_dec_to_alt_az gives imprecise values around 0  

#define RadToHundSec 360000/HrToRad

/*
typedef enum
{
	Aux1,
	Aux14,
	Aux16,
	Aux17,
	AuxOff
}AUX_CONTROL;
*/

#define MaxRefractIx 11

float R[MaxRefractIx+1][2];   //todo
float Refract=0;


extern float SidT;

static float JD=0;
static float JD1=0;
static float SidHr=0;
//float Sidt;
static float HrToRad=0;

//float LunT;  2004
//static float SolT=0;
//float UserT; 2004
static float OneRev=0;



//float RadToArcmin;
//float ArcminToRad;
//float RadToArcsec;

static float ArcsecToRad=0;

//#define RadToArcmin  60.*RadToDeg			//	3437.7467706
//#define ArcminToRad  DegToRad/60.			//  0.0002908882
//#define RadToArcsec  60.*RadToArcmin		//  206264.806236

#define RadToArcmin    3437.7467706
#define ArcminToRad    0.0002908882
#define RadToArcsec    206264.806236



//float RadToTenthsArcsec;  2004
//float TenthsArcsecToRad; 2004



//float SidT;

//float SidRate;
//float RadToDeg;
//float DegToRad;



#define  SidRate  1.00273790935 
#define	 RadToDeg 57.29577951	//360./OneRev;			//57.29577951
#define	 DegToRad 0.017453292	// OneRev/360.;	   		//0.017453292


extern struct stime sidti;
static char sid_chng;


/*
float sin(float x){
	
	
return x;	
	
}

float cos(float x){
	
	
return x;	
	
}

float asin(float x){
	
	
return x;	
	
}

float acos(float x){
	
	
return x;	
	
}
*/




void sprintf_float(char * str,float f){

signed int e;
signed int t;
unsigned char sign;
sign='+';
if (f<0) {
f=-f;
sign='-';

}
e=(signed int)(f);
//t=(signed int)(100000.*(f-(float)e));
t=(signed int)(10000000.*f)-(e*10000000);

 sprintf(str,"%c%d,%07d",sign,e,t);

}

void printf_float(float f){

signed int e;
signed int t;
unsigned char sign;
sign='+';
if (f<0) {
f=-f;
sign='-';

}
e=(signed int)(f);
//t=(signed int)(100000.*(f-(float)e));
t=(signed int)(10000000.*f)-(e*10000000);

 printf("%c%d,%07d",sign,e,t);

}


char sid_midnight(void)
{
	
	
return sid_chng;	
}


void sid_midnight_corr(char corr)
{
	
	sid_chng=corr;	
	
}

/*
GetHMSH( RadToHundSec*SidT + 0.5, &SidTimeHMSH);
gotoxy( VidMemXY.X, VidMemXY.Y);
DisplayHMSH( SidTimeHMSH);
*/

//************************************************************************************
//
// Radin -> degree (eg:43.1111) conversion
//
//*************************************************************************************


float rad_to_degfloat(float r,  int *deg,unsigned int *degres)

{
float Total;
float re;
 int mm;
	
	Total=r*RadToDeg;
    mm=( int)Total;
	re=(Total-mm)*10000.;
	if (Total<0)re=-re;
	
	*degres=(int)re;
	
	*deg=mm;

return(Total);	

}

//************************************************************************************
//
// degree (eg: 32.1111)-> radin conversion
//
//*************************************************************************************


float degfloat_to_rad( int deg,unsigned int degres)

{
float Total;
float x;
     
	       
	x=(float)degres/10000.;
	if (deg<0)x=-x;
	Total=(float)deg +x;
	
	Total=DegToRad*Total;
	
return(Total);	

}


//************************************************************************************
//
// Radin -> (eg:-10.20.30) conversion
//
//*************************************************************************************

void rad_to_deg(float r,unsigned char *sign,unsigned short *deg,unsigned char *min,unsigned char *sec)

{

//	long degHundSec;
//	long MinHundSec;
	long TotalSec;
	
	TotalSec=r*RadToArcsec;

	if( TotalSec < 0)
	{
		TotalSec = -TotalSec;
		*sign = MINUS;
	}
	else
		*sign = PLUS;

	*deg = (unsigned int) ( TotalSec/3600);
	*min = (char) ((TotalSec - (long) (*deg) * 3600)/60);
	*sec = (char) (TotalSec - *deg * 3600 - *min * 60);
	
	
	
	
	}

//************************************************************************************
//
// degree (eg: +32:12:21)-> radin conversion
//
//*************************************************************************************


float deg_to_rad(unsigned char sign,unsigned short deg,unsigned char min,unsigned char sec)

{
//float y;
float x;

x=(float)deg*DegToRad+(float)ArcminToRad*min+(float)ArcsecToRad*sec;
if( sign == MINUS)
		x = -x; 

//y=360*1000;
//x=x*HrToRad/y; 
return x;


}


//************************************************************************************
//
// Time (HH.MM.ss.hs)-> radin conversion
//
//*************************************************************************************


float time_to_rad(unsigned char sign,unsigned char hour,unsigned char min,unsigned char sec, unsigned char hundsec)

{
float y;
float x;

x=(hour*360000L)+(6000L*min)+(100*sec)+hundsec;


y=360*1000;
x=x*HrToRad/y; 
if (!sign)x=-x;
return x;
}


//************************************************************************************
//
// Radin -> time (HH.MM.ss.hs) conversion
//
//*************************************************************************************


void rad_to_time(float r,unsigned char *sign,unsigned char *hour,unsigned char *min,unsigned char *sec,unsigned char *hundsec)

{

	long HrHundSec;
	long MinHundSec;
	long TotalHundSec;
	
	if (r<0)
	  r=(M2_PI)+r;
	if (r>(M2_PI))r=r-(M2_PI);
	TotalHundSec=r*RadToHundSec;

	if( TotalHundSec < 0)
	{
		TotalHundSec =-TotalHundSec;
		*sign = MINUS;
	}
	else
		*sign = PLUS;

	*hour = (unsigned char) ( TotalHundSec/360000L);
	HrHundSec = (long) *hour*360000L;
	*min = (unsigned char) ((TotalHundSec - HrHundSec)/6000);
	MinHundSec = (long) *min*6000;
	*sec = (unsigned char) ((TotalHundSec - HrHundSec - MinHundSec)/100);
	*hundsec = (unsigned char) (TotalHundSec - HrHundSec - MinHundSec - *sec*100);
	
}


//************************************************************************************
//
// Radin -> time (HH.MM.ss.hs) conversion
//
//*************************************************************************************

void rad_to_time2(float r,unsigned char *sign,unsigned char *hour,unsigned char *min,unsigned char *sec,unsigned char *hundsec)

{

	long HrHundSec;
	long MinHundSec;
	long TotalHundSec;
	
	//if (r<0)
	//  r=(M2_PI)+r;
	//if (r>(M2_PI))r=r-(M2_PI);
	TotalHundSec=r*RadToHundSec;

	if( TotalHundSec < 0)
	{
		TotalHundSec =-TotalHundSec;
		*sign = MINUS;
	}
	else
		*sign = PLUS;

	*hour = (unsigned char) ( TotalHundSec/360000L);
	HrHundSec = (long) *hour*360000L;
	*min = (unsigned char) ((TotalHundSec - HrHundSec)/6000);
	MinHundSec = (long) *min*6000;
	*sec = (unsigned char) ((TotalHundSec - HrHundSec - MinHundSec)/100);
	*hundsec = (unsigned char) (TotalHundSec - HrHundSec - MinHundSec - *sec*100);
	
}


//************************************************************************************
//
// SidT (rad) -> SidT (hh.mm.ss)
//
//*************************************************************************************

void GetHMSH_SidT (void)
{


	long HrHundSec;
	long MinHundSec;
	long TotalHundSec;
	
	TotalHundSec=SidT*RadToHundSec;

	if( TotalHundSec < 0)
	{
		TotalHundSec = -TotalHundSec;
		sidti.sign = MINUS;
	}
	else
		sidti.sign = PLUS;

	sidti.hour = (int) ( TotalHundSec/360000L);
	HrHundSec = (long) sidti.hour*360000L;
	sidti.min = (int) ((TotalHundSec - HrHundSec)/6000);
	MinHundSec = (long) sidti.min*6000;
	sidti.sec = (int) ((TotalHundSec - HrHundSec - MinHundSec)/100);
	sidti.hundsec = (int) (TotalHundSec - HrHundSec - MinHundSec - sidti.sec*100);
}

static float Sid_x=0;
static float SidT_b=0;

void set_SidT(float s)

{
   SidT=s;
   SidT_b=s;
   Sid_x=0;
   SidT=s;
}



//************************************************************************************
//
// SidT increment by x* 10 milisec
//
//*************************************************************************************



void add_sid_time(float hunds)

{
float x;
//int h;

//x=hunds*7.2722052E-7;//(HrToRad/360000.);
x=hunds*7.2722058E-7;
//x=hunds*7.2722050E-7;
Sid_x=Sid_x+x;
SidT=SidT_b+Sid_x;;

if (Sid_x>0.001){
//  if (Sid_x>0.01){
   SidT_b=SidT;
   Sid_x=0;

}
if (SidT>=6.2831853071){SidT=0;SidT_b=0;Sid_x=0;
    sid_chng=1;} //24 ra utn 0-z
}




//************************************************************************************
//
// Init of the count module
//
//*************************************************************************************


void misc_calcInit(void)
{
/* all internal values kept in radians:
	1 revolution = 2 Pi Radians = 360 Degrees = 24 Hours = 1440 Minutes */
OneRev = 2*M_PI;
HrToRad = OneRev/24.;	 		//12.56637061

/*
SidRate = 1.00273790935; 
RadToDeg = 57.29577951;//360./OneRev;			//57.29577951
DegToRad =0.017453292;// OneRev/360.;	   		//0.017453292

*/
//ArcminToRad = DegToRad/60.;
/*
RadToArcmin = 60.*RadToDeg;			//	3437.7467706
ArcminToRad = DegToRad/60.;			//  0.0002908882
RadToArcsec = 60.*RadToArcmin;		//  206264.806236
*/
ArcsecToRad = ArcminToRad/60.;

InitRefract();
}


//************************************************************************************
//
// calculating Julian date
//
//*************************************************************************************


void CalcJD(  long Y,  int M,  int D,  float Tz,  int DST, int h,
float m, float s)
{
	float A;
	float B;

	/* return 1st formula if Gregorian calendar, otherwise 2nd formula for Julian calendar: Sky and
	Telescope, August, 1991, pg 183 */
	if( (Y > 1582) || (Y == 1582 && M > 10) || (Y == 1582 && M == 10 && D > 15))
		A = 367*Y - 7*(Y + (M + 9)/12)/4 - 3*((Y + (M - 9)/7)/100 + 1)/4 + 275*M/9 + D + 1721029L;
	else
		A = 367*Y - 7*(Y + 5001 + (M - 9)/7)/4 + 275*M/9 + D + 1729777L;
	/* subtract 12hrs since JD starts at 12noon UT */
	B = (Tz - DST - 12 + h + m/60. + s/3600)/24;
	JD = A ;//+ B;
	JD1= B;
}

//************************************************************************************
//
// Sid clock
//
//*************************************************************************************

float CalcSidHr( long Y,  int M, int D, float Tz,  int DST,  int h,
float m, float s, float LongitudeDeg)
{
	/* JD at 0hrs UT (will be in form of a whole number + 0.5) */
	float JD0HrUT; 
	/* fractional part of JD beyond JD0HrUT */
	float FracDay;
	/* intermediate calculated result */
	float T; 
	/* sidereal time at 0hrs UT */
	float Sid0HrUT;
	
	float xx;
	
	LongitudeDeg=LongitudeDeg*RadToDeg;	//because we have it in RAD
	CalcJD( Y, M, D, Tz, DST, h, m, s);
	FracDay=(JD - ((long)(JD+JD1))+JD1);

	
	/* FracDay meas. from 0hr UT or < JD > .5 */
	if( FracDay > 0.5)
		FracDay -= 0.5;
	else
		FracDay += 0.5;   	  	 //JD1+JD-FacDay<>with this 
	xx=JD1-FracDay;		  	  	 //why is it imprecise????
	JD0HrUT = JD + xx;

	/* Astronomical Formulae for Calculators, by Jean Meeus, pg 39 */
	T = (JD0HrUT - 2415020.)/36525.; 
	Sid0HrUT = 6.6460656 + 2400.051262*T + 0.00002581*T*T;
	//SidHr = fmod( FracDay*SidRate*24. + Sid0HrUT - LongitudeDeg/15., 24); 
	xx= FracDay*SidRate*24. + Sid0HrUT - LongitudeDeg/15.;
	SidHr=(xx - ((long)(xx/24))*24);
	xx = SidHr*HrToRad;
   // GetHMSH();
   return (xx);
}

/*
GetHMSH( RadToHundSec*SidT + 0.5, &SidTimeHMSH);
gotoxy( VidMemXY.X, VidMemXY.Y);
DisplayHMSH( SidTimeHMSH);

//void GetHMSH( long TotalHundSec, struct stime* V)
void GetHMSH (void)
{


	long HrHundSec;
	long MinHundSec;

	if( TotalHundSec < 0)
	{
		TotalHundSec = -TotalHundSec;
		V->sign = MINUS;
	}
	else
		V->sign = PLUS;

	V->hour = (int) ( TotalHundSec/360000L);
	HrHundSec = (long) V->hour*360000L;
	V->min = (int) ((TotalHundSec - HrHundSec)/6000);
	MinHundSec = (long) V->min*6000;
	V->sec = (int) ((TotalHundSec - HrHundSec - MinHundSec)/100);
	V->hundsec = (int) (TotalHundSec - HrHundSec - MinHundSec - V->sec*100);
}

*/




/* refraction makes an object appear higher in the sky than it really is when close to the horizon:
if need to move to alt = 0, instead move to alt = 0.5, since object at alt = 0 appears to be at alt
= 0.5; if measured alt from object = 0.5, alt of object to use in calculations = 0; refraction
handled by routines that translate between scope's position (AccumAMs) and sky altitude (Current.Alt)

interpolate:
1. find points that the angle fits between
	ex: angle of 10 has end point of R[10][0] and beginning point of R[9][0]
2. get position between end points
	position = (a-bp)/(ep-bp)
	ex: a=1, bp=2, ep=0
		 position = (1-2)/(0-2) = .5
3. refraction = amount of refraction at beginning point +
					 position * (amount of refract at end point - amount of refract at beg point)
	r = br + p*(er-br), r = br + (a-bp)/(ep-bp)*(er-br), r = br + (a-bp)*(er-br)/(ep-bp)
	ex: br=18, er=34.5
		 r = 18 + .5*(34.5-18) = 26.25arcmin
4. corrected angle = angle + refraction
	ex: ca = a+r = ca = 1deg + 26.25arcmin = 1.4375deg

to reverse: have corrected angle of ca, find altitude of a
	ex: ca = 1deg + 26.25arcmin = 86.25arcmin, solve for a
1. ca = a + r, a = ca - r, a = ca - br - (a-bp)*(er-br)/(ep-bp),
	a*(ep-bp)+(a-bp)*(er-br) = (ca-br)*(ep-bp),
	a*ep-a*bp+a*er-a*br-bp*er+bp*br = ca*ep-ca*bp-br*ep+br*bp,
	a*(ep-bp+er-br) = ca*ep-ca*bp-br*ep+br*bp+bp*er-bp*br,
	a*(ep-bp+er-br) = ca*(ep-bp)-br*ep+bp*er,
	a = (ca*(ep-bp)-br*ep+bp*er) / (ep-bp+er-br),

	ex: convert all units to armin...
		 a = 86.25-18-(34.5-18)(60-120)/(0-120) = 86.25-18-8.25 = 60 (from 1st line)
		 a = (86.25*(0-120)-18*0+120*34.5)/(0-120+34.5-18) = (-10350+4140)/(-103.5) = 60
*/



/* refraction... */






void InitRefract( void)
{
	/* table of refraction per altitude angle:
	R[][0] is altitude angle in degrees
	R[][1] is refraction in arcminutes of corresponding altitude angles */
	/*R[0][0] = 90.;   R[0][1] = 0.;
	R[1][0] = 60.;   R[1][1] = .55;
	R[2][0] = 30.;   R[2][1] = 1.7;
	R[3][0] = 20.;   R[3][1] = 2.6;
	R[4][0] = 15.;   R[4][1] = 3.5;
	R[5][0] = 10.;   R[5][1] = 5.2;
	R[6][0] =  8.;   R[6][1] = 6.4;
	R[7][0] =  6.;   R[7][1] = 8.3;
	R[8][0] =  4.;   R[8][1] = 11.5;
	R[9][0] =  2.;   R[9][1] = 18;
	R[10][0] = 0.;   R[10][1] = 34.5;*/
	
	R[0][0] = 90.;   R[0][1] = 0.;
	R[1][0] = 60.;   R[1][1] = .65;
	R[2][0] = 30.;   R[2][1] = 1.7;
	R[3][0] = 20.;   R[3][1] = 2.7;
	R[4][0] = 15.;   R[4][1] = 3.6;
	R[5][0] = 10.;   R[5][1] = 5.3;
	R[6][0] =  8.;   R[6][1] = 6.5;
	R[7][0] =  6.;   R[7][1] = 8.4;
	R[8][0] =  4.;   R[8][1] = 11.7;
	R[9][0] =  2.;   R[9][1] = 18.2;
	R[10][0] = 0.;   R[10][1] = 34.3;

	Refract = 0;}

/* this function calcs refraction at a particular aimed altitude,
ie, at the horizon, refraction will be 34.5 arcmin */
void CalcRefractScopeToSky( float Alt)
{
	int Ix;
	float a;
	float bp;
	float ep;
	float br;
	float er;

	/* Alt is in radians; convert to degrees for use with refraction table */
	a = Alt*RadToDeg;
	if( a < 0)
		a = -a;
	if( a > 90)
		a = 90;
	for( Ix = 0; a < R[Ix][0] && Ix < MaxRefractIx; Ix++)
		;
	bp = R[Ix-1][0];
	ep = R[Ix][0];
	br = R[Ix-1][1];
	er = R[Ix][1];

	Refract = br + (a-bp)*(er-br)/(ep-bp);
	Refract *= ArcminToRad;
}

/* this function calcs refraction to remove from an already compensated altitude,
 ie, at 34.5 arcmin below horizon, value to remove is 34.5 arcmin */
void CalcRefractSkyToScope( float Alt)
{
	int Ix;
	float a;
	float bp;
	float ep;
	float br;
	float er;
	float a1;

	/* Alt is in radians; convert to degrees for use with refraction table */
	a = Alt*RadToDeg;
	if( a < 0)
		a = -a;
	if( a > 90)
		a = 90;
	for( Ix = 0; a < R[Ix][0] && Ix < MaxRefractIx; Ix++)
		;
	bp = R[Ix-1][0];
	ep = R[Ix][0];
	br = R[Ix-1][1];
	er = R[Ix][1];

	/* convert deg to arcmin */
	a *= 60.;
	bp *= 60;
	ep *= 60;
	a1 = (a*(ep-bp)-br*ep+bp*er) / (ep-bp+er-br);
	Refract = Alt - a1*ArcminToRad;
}

float  acose( float arg)
{
   if( arg >= 1.)
      return( 0.);
   if( arg+1. <= 0.)
      return( M_PI);
   return( acos( arg));
}



//************************************************************************************
//
// Ra_Dec -> Alt_Az conversion
//
//*************************************************************************************



double hra;

 void ra_dec_to_alt_az(  float hr_ang,  float dec,
        float  *alt, float  *az,  float lat)
{
   double temp;
   double x;
   double cos_lat;
   double y;
   double ddec;
   double dhr_ang;
   double dalt;
   double dlat;
   
   dlat=lat;
   dhr_ang=hr_ang;
   ddec=dec;   
   hra=dhr_ang;
   cos_lat = cos( dlat);
   temp=sin( dlat) * sin( ddec);
   x=cos_lat * cos( ddec); 
   y=cos( dhr_ang)*x;
 //  y=x*0.999999999999;
 
   dalt = asin( temp + y);
   *alt=dalt;
   if( cos_lat < .000000001)         /* polar case -.00001 2010.06.03*/
      *az = hr_ang;
   else
      {
	   
	   x=cos( dalt) * cos_lat;
	  y=sin( dalt) * sin( dlat);
      temp = (sin( ddec) - y) / (x);
      //y = M_PI - acose( temp);
	  y=acose( temp);
      //*az = ((sin( hr_ang) < 0.) ? y : -y);
	  if ((sin( dhr_ang) < 0.))*az=y;
	  	 else *az=M2_PI-y;
	  
//	  *az=y;
///	  printf(".");
	  
	  if (dhr_ang < 0.001){			//nearly at the meridian
//		printf("Me");  
		*az=(M_PI+dhr_ang*1.35); 
	  }
	   
	  else  if (dhr_ang > (M2_PI-0.001)){			
//		  		printf("Mo");  
		  		*az=(M_PI-(M2_PI-dhr_ang)*1.35); 
		  	  }
	  
      }
   
}


 //************************************************************************************
 //
 // Alt_Az  ->   Ra_Dec conversion
 //
 //*************************************************************************************



 void alt_az_to_ra_dec( float alt, float az,
                         float  *hr_ang,
                         float  *dec,  float lat)
{
 /*  float temp;                        //no double needed here????
   float sin_dec;
   float cos_lat;
   float x;
   float y;
*/
   double temp;                        //no double needed here 2011.10.28????
   double sin_dec;
   double cos_lat;
   double x;
   double y;
   /*
   double ddec;
   double dhr_ang;
   double dalt;
   double dlat;
*/

   cos_lat = cos( lat);

   if( alt > M_PI / 2.)
      {
      alt = M_PI - alt;
      az += M_PI;
      }
   if( alt < -M_PI / 2.)
      {
      alt = -M_PI - alt;
      az -= M_PI;
      }
   x=sin( lat) * sin( alt);	 
   temp=cos_lat * cos( alt) ;
   y=temp* cos( az); 
   sin_dec = x + y;
   *dec = asin( sin_dec);
   if( cos_lat < .00001)         /* polar case */
      *hr_ang = az + M_PI;
   else
      {
      temp = cos_lat * cos( *dec);
      x = (sin( alt) - sin( lat) * sin_dec);
	  y=x/temp;
      temp = acose( -y);
      if( sin( az) > 0.)
         *hr_ang = M_PI + temp;//-
      else
         *hr_ang = M_PI - temp;//+
      }
	y=*hr_ang;  
}

 
 

 //**********************************************************************
 //BCD to Binary conversion
 //**********************************************************************
 unsigned char bcd_bin(unsigned char bc)
 {
 unsigned char x;

 x=(bc&0x0f)+((bc&0xf0)>>4)*10;
 return(x); 


 }

 //**********************************************************************
 //
 //**********************************************************************

 unsigned char bcd(unsigned char n)
 {
 unsigned char ta;
 unsigned char e;
 unsigned char x;

 ta=n/10;
 e=n-(ta*10);
 x=(ta<<4)|e;
 return(x);

 }
 
//**********************************************************************
// Check sum routine for save operation control
//**********************************************************************

 
 char chk_sum(void *scr, int size)

 {
 int i;
 char chk;
 char *sss;
 sss=scr;
 chk=0;
 for (i=0;i<size;i++)
  {
   chk=chk^*sss++;
  }

 return(chk);
 }
 

//**********************************************************************
// The built in Fabs function warning
//**********************************************************************

 float fabs2 (float ff){
 	
 if (ff<0)	
   return -ff;
 else return ff;
 	
 }
 
